Index: trunk/src/VBox/Runtime/common/dbg/dbgmodcontainer.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/dbg/dbgmodcontainer.cpp	(revision 85154)
+++ trunk/src/VBox/Runtime/common/dbg/dbgmodcontainer.cpp	(revision 85160)
@@ -993,5 +993,5 @@
  *                      created manually later on.
  */
-int rtDbgModContainerCreate(PRTDBGMODINT pMod, RTUINTPTR cbSeg)
+DECLHIDDEN(int) rtDbgModContainerCreate(PRTDBGMODINT pMod, RTUINTPTR cbSeg)
 {
     PRTDBGMODCTN pThis = (PRTDBGMODCTN)RTMemAlloc(sizeof(*pThis));
Index: trunk/src/VBox/Runtime/common/log/tracelogreader.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/log/tracelogreader.cpp	(revision 85154)
+++ trunk/src/VBox/Runtime/common/log/tracelogreader.cpp	(revision 85160)
@@ -239,7 +239,6 @@
 
 /*********************************************************************************************************************************
-*   Defined Constants And Macros                                                                                                 *
+*   Internal Functions                                                                                                           *
 *********************************************************************************************************************************/
-
 static DECLCALLBACK(int) rtTraceLogRdrHdrRecvd(PRTTRACELOGRDRINT pThis, RTTRACELOGRDRPOLLEVT *penmEvt, bool *pfContinuePoll);
 static DECLCALLBACK(int) rtTraceLogRdrHdrDescRecvd(PRTTRACELOGRDRINT pThis, RTTRACELOGRDRPOLLEVT *penmEvt, bool *pfContinuePoll);
@@ -256,20 +255,21 @@
 /**
  * State handlers.
- */
-static PFNRTTRACELOGRDRSTATEHANDLER g_apfnStateHandlers[] =
-{
-    NULL,
-    rtTraceLogRdrHdrRecvd,
-    rtTraceLogRdrHdrDescRecvd,
-    rtTraceLogRdrMagicRecvd,
-    rtTraceLogRdrEvtDescRecvd,
-    rtTraceLogRdrEvtDescIdRecvd,
-    rtTraceLogRdrEvtDescDescriptionRecvd,
-    rtTraceLogRdrEvtItemDescRecvd,
-    rtTraceLogRdrEvtItemDescNameRecvd,
-    rtTraceLogRdrEvtItemDescDescriptionRecvd,
-    rtTraceLogRdrEvtMarkerRecvd,
-    rtTraceLogRdrEvtDataRecvd,
-    NULL
+ * @note The struct wrapper is for working around a Clang nothrow attrib oddity.
+ */
+static struct { PFNRTTRACELOGRDRSTATEHANDLER pfn; } g_aStateHandlers[] =
+{
+    { NULL },
+    { rtTraceLogRdrHdrRecvd },
+    { rtTraceLogRdrHdrDescRecvd },
+    { rtTraceLogRdrMagicRecvd },
+    { rtTraceLogRdrEvtDescRecvd },
+    { rtTraceLogRdrEvtDescIdRecvd },
+    { rtTraceLogRdrEvtDescDescriptionRecvd },
+    { rtTraceLogRdrEvtItemDescRecvd },
+    { rtTraceLogRdrEvtItemDescNameRecvd },
+    { rtTraceLogRdrEvtItemDescDescriptionRecvd },
+    { rtTraceLogRdrEvtMarkerRecvd },
+    { rtTraceLogRdrEvtDataRecvd },
+    { NULL }
 };
 
@@ -1570,5 +1570,5 @@
             {
                 /* Act according to the current state. */
-                rc = g_apfnStateHandlers[pThis->enmState](pThis, penmEvt, &fContinue);
+                rc = g_aStateHandlers[pThis->enmState].pfn(pThis, penmEvt, &fContinue);
             }
             else
Index: trunk/src/VBox/Runtime/common/path/RTPathParentLength.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathParentLength.cpp	(revision 85154)
+++ trunk/src/VBox/Runtime/common/path/RTPathParentLength.cpp	(revision 85160)
@@ -87,5 +87,5 @@
  *          double-slash prefix as parent.
  */
-size_t RTPathParentLength(const char *pszPath)
+RTDECL(size_t) RTPathParentLength(const char *pszPath)
 {
 #if RTPATH_STYLE == RTPATH_STR_F_STYLE_DOS
Index: trunk/src/VBox/Runtime/common/string/ministring.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/string/ministring.cpp	(revision 85154)
+++ trunk/src/VBox/Runtime/common/string/ministring.cpp	(revision 85160)
@@ -1144,5 +1144,5 @@
 }
 
-const RTCString operator+(const RTCString &a_rStr1, const RTCString &a_rStr2)
+RTDECL(const RTCString) operator+(const RTCString &a_rStr1, const RTCString &a_rStr2)
 {
     RTCString strRet(a_rStr1);
@@ -1151,5 +1151,5 @@
 }
 
-const RTCString operator+(const RTCString &a_rStr1, const char *a_pszStr2)
+RTDECL(const RTCString) operator+(const RTCString &a_rStr1, const char *a_pszStr2)
 {
     RTCString strRet(a_rStr1);
@@ -1158,5 +1158,5 @@
 }
 
-const RTCString operator+(const char *a_psz1, const RTCString &a_rStr2)
+RTDECL(const RTCString) operator+(const char *a_psz1, const RTCString &a_rStr2)
 {
     RTCString strRet(a_psz1);