Index: trunk/src/VBox/Main/src-client/ConsoleImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/ConsoleImpl.cpp	(revision 85286)
+++ trunk/src/VBox/Main/src-client/ConsoleImpl.cpp	(revision 85300)
@@ -1791,5 +1791,5 @@
     if (SUCCEEDED(hrc))
     {
-        fireGuestPropertyChangedEvent(pConsole->mEventSource, pConsole->i_getId().raw(), name.raw(), value.raw(), flags.raw());
+        ::FireGuestPropertyChangedEvent(pConsole->mEventSource, pConsole->i_getId().raw(), name.raw(), value.raw(), flags.raw());
         rc = VINF_SUCCESS;
     }
@@ -3000,5 +3000,5 @@
     /* Notify console callbacks after the folder is added to the list. */
     alock.release();
-    fireSharedFolderChangedEvent(mEventSource, Scope_Session);
+    ::FireSharedFolderChangedEvent(mEventSource, Scope_Session);
 
     LogFlowThisFunc(("Leaving for '%s' -> '%s'\n", aName.c_str(), aHostPath.c_str()));
@@ -3059,5 +3059,5 @@
     /* Notify console callbacks after the folder is removed from the list. */
     alock.release();
-    fireSharedFolderChangedEvent(mEventSource, Scope_Session);
+    ::FireSharedFolderChangedEvent(mEventSource, Scope_Session);
 
     LogFlowThisFunc(("Leaving for '%s'\n", aName.c_str()));
@@ -4069,5 +4069,5 @@
     /* notify console callbacks on success */
     if (SUCCEEDED(rc))
-        fireNetworkAdapterChangedEvent(mEventSource, aNetworkAdapter);
+        ::FireNetworkAdapterChangedEvent(mEventSource, aNetworkAdapter);
 
     LogFlowThisFunc(("Leaving rc=%#x\n", rc));
@@ -5037,5 +5037,5 @@
     /* notify console callbacks on success */
     if (SUCCEEDED(hrc))
-        fireAudioAdapterChangedEvent(mEventSource, aAudioAdapter);
+        ::FireAudioAdapterChangedEvent(mEventSource, aAudioAdapter);
 
     LogFlowThisFunc(("Leaving rc=%#x\n", S_OK));
@@ -5192,5 +5192,5 @@
 
     if (SUCCEEDED(hrc))
-        fireSerialPortChangedEvent(mEventSource, aSerialPort);
+        ::FireSerialPortChangedEvent(mEventSource, aSerialPort);
 
     LogFlowThisFunc(("Leaving rc=%#x\n", S_OK));
@@ -5208,5 +5208,5 @@
     AssertComRCReturnRC(autoCaller.rc());
 
-    fireParallelPortChangedEvent(mEventSource, aParallelPort);
+    ::FireParallelPortChangedEvent(mEventSource, aParallelPort);
 
     LogFlowThisFunc(("Leaving rc=%#x\n", S_OK));
@@ -5224,5 +5224,5 @@
     AssertComRCReturnRC(autoCaller.rc());
 
-    fireStorageControllerChangedEvent(mEventSource, Bstr(aMachineId.toString()).raw(), Bstr(aControllerName).raw());
+    ::FireStorageControllerChangedEvent(mEventSource, Bstr(aMachineId.toString()).raw(), Bstr(aControllerName).raw());
 
     LogFlowThisFunc(("Leaving rc=%#x\n", S_OK));
@@ -5252,5 +5252,5 @@
     /* notify console callbacks on success */
     if (SUCCEEDED(rc))
-        fireMediumChangedEvent(mEventSource, aMediumAttachment);
+        ::FireMediumChangedEvent(mEventSource, aMediumAttachment);
 
     LogFlowThisFunc(("Leaving rc=%#x\n", rc));
@@ -5285,5 +5285,5 @@
     /* notify console callbacks on success */
     if (SUCCEEDED(rc))
-        fireCPUChangedEvent(mEventSource, aCPU, aRemove);
+        ::FireCPUChangedEvent(mEventSource, aCPU, aRemove);
 
     LogFlowThisFunc(("Leaving rc=%#x\n", rc));
@@ -5328,5 +5328,5 @@
     {
         alock.release();
-        fireCPUExecutionCapChangedEvent(mEventSource, aExecutionCap);
+        ::FireCPUExecutionCapChangedEvent(mEventSource, aExecutionCap);
     }
 
@@ -5372,5 +5372,5 @@
     {
         alock.release();
-        fireClipboardModeChangedEvent(mEventSource, aClipboardMode);
+        ::FireClipboardModeChangedEvent(mEventSource, aClipboardMode);
     }
 
@@ -5416,5 +5416,5 @@
     {
         alock.release();
-        fireClipboardFileTransferModeChangedEvent(mEventSource, aEnabled ? TRUE : FALSE);
+        ::FireClipboardFileTransferModeChangedEvent(mEventSource, aEnabled ? TRUE : FALSE);
     }
 
@@ -5456,5 +5456,5 @@
     {
         alock.release();
-        fireDnDModeChangedEvent(mEventSource, aDnDMode);
+        ::FireDnDModeChangedEvent(mEventSource, aDnDMode);
     }
 
@@ -5595,5 +5595,5 @@
     {
         alock.release();
-        fireVRDEServerChangedEvent(mEventSource);
+        ::FireVRDEServerChangedEvent(mEventSource);
     }
 
@@ -5606,5 +5606,5 @@
     AssertComRCReturnVoid(autoCaller.rc());
 
-    fireVRDEServerInfoChangedEvent(mEventSource);
+    ::FireVRDEServerInfoChangedEvent(mEventSource);
 }
 
@@ -5742,5 +5742,5 @@
         {
             alock.release();
-            fireRecordingChangedEvent(mEventSource);
+            ::FireRecordingChangedEvent(mEventSource);
         }
 
@@ -5763,5 +5763,5 @@
     AssertComRCReturnRC(autoCaller.rc());
 
-    fireUSBControllerChangedEvent(mEventSource);
+    ::FireUSBControllerChangedEvent(mEventSource);
 
     return S_OK;
@@ -5788,5 +5788,5 @@
     {
         alock.release();
-        fireSharedFolderChangedEvent(mEventSource, aGlobal ? Scope_Global : Scope_Machine);
+        ::FireSharedFolderChangedEvent(mEventSource, aGlobal ? Scope_Global : Scope_Machine);
     }
 
@@ -6025,5 +6025,5 @@
     {
         alock.release();
-        fireBandwidthGroupChangedEvent(mEventSource, aBandwidthGroup);
+        ::FireBandwidthGroupChangedEvent(mEventSource, aBandwidthGroup);
     }
 
@@ -6059,5 +6059,5 @@
     /* notify console callbacks on success */
     if (SUCCEEDED(rc))
-        fireStorageDeviceChangedEvent(mEventSource, aMediumAttachment, aRemove, aSilent);
+        ::FireStorageDeviceChangedEvent(mEventSource, aMediumAttachment, aRemove, aSilent);
 
     LogFlowThisFunc(("Leaving rc=%#x\n", rc));
@@ -6098,5 +6098,5 @@
     /* notify console callbacks on success */
     if (SUCCEEDED(hrc))
-        fireExtraDataChangedEvent(mEventSource, aMachineId, aKey, aVal);
+        ::FireExtraDataChangedEvent(mEventSource, aMachineId, aKey, aVal);
 
     LogFlowThisFunc(("Leaving hrc=%#x\n", hrc));
@@ -7273,5 +7273,5 @@
     if (pu8Shape)
         memcpy(shape.raw(), pu8Shape, cbShape);
-    fireMousePointerShapeChangedEvent(mEventSource, fVisible, fAlpha, xHot, yHot, width, height, ComSafeArrayAsInParam(shape));
+    ::FireMousePointerShapeChangedEvent(mEventSource, fVisible, fAlpha, xHot, yHot, width, height, ComSafeArrayAsInParam(shape));
 
 #if 0
@@ -7289,5 +7289,5 @@
     AssertComRCReturnVoid(autoCaller.rc());
 
-    fireMouseCapabilityChangedEvent(mEventSource, supportsAbsolute, supportsRelative, supportsMT, needsHostCursor);
+    ::FireMouseCapabilityChangedEvent(mEventSource, supportsAbsolute, supportsRelative, supportsMT, needsHostCursor);
 }
 
@@ -7296,5 +7296,5 @@
     AutoCaller autoCaller(this);
     AssertComRCReturnVoid(autoCaller.rc());
-    fireStateChangedEvent(mEventSource, machineState);
+    ::FireStateChangedEvent(mEventSource, machineState);
 }
 
@@ -7304,5 +7304,5 @@
     AssertComRCReturnVoid(autoCaller.rc());
 
-    fireAdditionsStateChangedEvent(mEventSource);
+    ::FireAdditionsStateChangedEvent(mEventSource);
 }
 
@@ -7327,5 +7327,5 @@
     AssertComRCReturnVoid(autoCaller.rc());
 
-    fireKeyboardLedsChangedEvent(mEventSource, fNumLock, fCapsLock, fScrollLock);
+    ::FireKeyboardLedsChangedEvent(mEventSource, fNumLock, fCapsLock, fScrollLock);
 }
 
@@ -7336,5 +7336,5 @@
     AssertComRCReturnVoid(autoCaller.rc());
 
-    fireUSBDeviceStateChangedEvent(mEventSource, aDevice, aAttached, aError);
+    ::FireUSBDeviceStateChangedEvent(mEventSource, aDevice, aAttached, aError);
 }
 
@@ -7344,5 +7344,5 @@
     AssertComRCReturnVoid(autoCaller.rc());
 
-    fireRuntimeErrorEvent(mEventSource, aFatal, aErrorID, aMessage);
+    ::FireRuntimeErrorEvent(mEventSource, aFatal, aErrorID, aMessage);
 }
 
@@ -10301,5 +10301,5 @@
                     vrc = pConsole->i_recordingEnable(fRecordingEnabled, &alock);
                     if (RT_SUCCESS(vrc))
-                        fireRecordingChangedEvent(pConsole->mEventSource);
+                        ::FireRecordingChangedEvent(pConsole->mEventSource);
                     else
                     {
@@ -10921,5 +10921,5 @@
                     {
                         pThis->pConsole->mMachine->SaveSettings();
-                        fireMediumChangedEvent(pThis->pConsole->mEventSource, pNewMediumAtt);
+                        ::FireMediumChangedEvent(pThis->pConsole->mEventSource, pNewMediumAtt);
                     }
 
Index: trunk/src/VBox/Main/src-client/DisplayImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/DisplayImpl.cpp	(revision 85286)
+++ trunk/src/VBox/Main/src-client/DisplayImpl.cpp	(revision 85300)
@@ -788,20 +788,14 @@
     {
         if (fDisabled)
-            fireGuestMonitorChangedEvent(mParent->i_getEventSource(),
-                                         GuestMonitorChangedEventType_Disabled,
-                                         uScreenId,
-                                         0, 0, 0, 0);
+            ::FireGuestMonitorChangedEvent(mParent->i_getEventSource(),
+                                           GuestMonitorChangedEventType_Disabled,  uScreenId, 0, 0, 0, 0);
         else
-            fireGuestMonitorChangedEvent(mParent->i_getEventSource(),
-                                         GuestMonitorChangedEventType_Enabled,
-                                         uScreenId,
-                                         xOrigin, yOrigin, w, h);
+            ::FireGuestMonitorChangedEvent(mParent->i_getEventSource(),
+                                           GuestMonitorChangedEventType_Enabled, uScreenId, xOrigin, yOrigin, w, h);
     }
 
     if (fNewOrigin)
-        fireGuestMonitorChangedEvent(mParent->i_getEventSource(),
-                                     GuestMonitorChangedEventType_NewOrigin,
-                                     uScreenId,
-                                     xOrigin, yOrigin, 0, 0);
+        ::FireGuestMonitorChangedEvent(mParent->i_getEventSource(),
+                                       GuestMonitorChangedEventType_NewOrigin, uScreenId, xOrigin, yOrigin, 0, 0);
 
     /* Inform the VRDP server about the change of display parameters. */
@@ -1714,5 +1708,5 @@
     }
     /* Notify listeners. */
-    fireGuestMonitorInfoChangedEvent(mParent->i_getEventSource(), aDisplay);
+    ::FireGuestMonitorInfoChangedEvent(mParent->i_getEventSource(), aDisplay);
     return S_OK;
 }
@@ -3257,9 +3251,6 @@
         {
             pFBInfo->fDisabled = false;
-            fireGuestMonitorChangedEvent(pThis->mParent->i_getEventSource(),
-                                         GuestMonitorChangedEventType_Enabled,
-                                         uScreenId,
-                                         pFBInfo->xOrigin, pFBInfo->yOrigin,
-                                         pFBInfo->w, pFBInfo->h);
+            ::FireGuestMonitorChangedEvent(pThis->mParent->i_getEventSource(), GuestMonitorChangedEventType_Enabled, uScreenId,
+                                           pFBInfo->xOrigin, pFBInfo->yOrigin, pFBInfo->w, pFBInfo->h);
         }
     }
@@ -3614,5 +3605,5 @@
         y += pThis->maFramebuffers[aScreenId].yOrigin;
     }
-    fireCursorPositionChangedEvent(pThis->mParent->i_getEventSource(), RT_BOOL(fFlags & VBVA_CURSOR_VALID_DATA), x, y);
+    ::FireCursorPositionChangedEvent(pThis->mParent->i_getEventSource(), RT_BOOL(fFlags & VBVA_CURSOR_VALID_DATA), x, y);
 }
 
Index: trunk/src/VBox/Main/src-client/DisplayImplLegacy.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/DisplayImplLegacy.cpp	(revision 85286)
+++ trunk/src/VBox/Main/src-client/DisplayImplLegacy.cpp	(revision 85300)
@@ -952,17 +952,14 @@
                 {
                     pFBInfo->fDisabled = false;
-                    fireGuestMonitorChangedEvent(mParent->i_getEventSource(),
-                                                 GuestMonitorChangedEventType_Enabled,
-                                                 uScreenId,
-                                                 pFBInfo->xOrigin, pFBInfo->yOrigin,
-                                                 pFBInfo->w, pFBInfo->h);
+                    ::FireGuestMonitorChangedEvent(mParent->i_getEventSource(), GuestMonitorChangedEventType_Enabled, uScreenId,
+                                                   pFBInfo->xOrigin, pFBInfo->yOrigin, pFBInfo->w, pFBInfo->h);
                 }
 
                 i_handleDisplayResize(uScreenId, pScreen->bitsPerPixel,
-                                                      (uint8_t *)pvVRAM + pFBInfo->u32Offset,
-                                                      pScreen->u32LineSize,
-                                                      pScreen->u16Width, pScreen->u16Height,
-                                                      VBVA_SCREEN_F_ACTIVE,
-                                                      pScreen->xOrigin, pScreen->yOrigin, false);
+                                      (uint8_t *)pvVRAM + pFBInfo->u32Offset,
+                                      pScreen->u32LineSize,
+                                      pScreen->u16Width, pScreen->u16Height,
+                                      VBVA_SCREEN_F_ACTIVE,
+                                      pScreen->xOrigin, pScreen->yOrigin, false);
             }
         }
Index: trunk/src/VBox/Main/src-client/GuestCtrlImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/GuestCtrlImpl.cpp	(revision 85286)
+++ trunk/src/VBox/Main/src-client/GuestCtrlImpl.cpp	(revision 85300)
@@ -271,5 +271,5 @@
     alock.release(); /* Release lock before firing off event. */
 
-    fireGuestSessionRegisteredEvent(mEventSource, pSession, false /* Unregistered */);
+    ::FireGuestSessionRegisteredEvent(mEventSource, pSession, false /* Unregistered */);
     pSession.setNull();
 
@@ -359,6 +359,5 @@
         alock.release(); /* Release lock before firing off event. */
 
-        fireGuestSessionRegisteredEvent(mEventSource, pGuestSession,
-                                        true /* Registered */);
+        ::FireGuestSessionRegisteredEvent(mEventSource, pGuestSession, true /* Registered */);
     }
     catch (int rc2)
Index: trunk/src/VBox/Main/src-client/GuestFileImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/GuestFileImpl.cpp	(revision 85286)
+++ trunk/src/VBox/Main/src-client/GuestFileImpl.cpp	(revision 85300)
@@ -529,6 +529,5 @@
                 data.initFrom((BYTE*)dataCb.u.read.pvData, cbRead);
 
-                fireGuestFileReadEvent(mEventSource, mSession, this, mData.mOffCurrent,
-                                       cbRead, ComSafeArrayAsInParam(data));
+                ::FireGuestFileReadEvent(mEventSource, mSession, this, mData.mOffCurrent, cbRead, ComSafeArrayAsInParam(data));
             }
             break;
@@ -560,5 +559,5 @@
                 com::SafeArray<BYTE> data((size_t)cbRead);
                 data.initFrom(pbData, cbRead);
-                fireGuestFileReadEvent(mEventSource, mSession, this, offNew, cbRead, ComSafeArrayAsInParam(data));
+                ::FireGuestFileReadEvent(mEventSource, mSession, this, offNew, cbRead, ComSafeArrayAsInParam(data));
                 rc = VINF_SUCCESS;
             }
@@ -588,5 +587,5 @@
                 alock.release();
 
-                fireGuestFileWriteEvent(mEventSource, mSession, this, mData.mOffCurrent, cbWritten);
+                ::FireGuestFileWriteEvent(mEventSource, mSession, this, mData.mOffCurrent, cbWritten);
             }
             break;
@@ -613,13 +612,6 @@
             alock.release();
 
-            try
-            {
-                fireGuestFileWriteEvent(mEventSource, mSession, this, offNew, cbWritten);
-                rc = VINF_SUCCESS;
-            }
-            catch (std::bad_alloc &)
-            {
-                rc = VERR_NO_MEMORY;
-            }
+            HRESULT hrc2 = ::FireGuestFileWriteEvent(mEventSource, mSession, this, offNew, cbWritten);
+            rc = SUCCEEDED(hrc2) ? VINF_SUCCESS : Global::vboxStatusCodeFromCOM(hrc2);
             break;
         }
@@ -641,5 +633,5 @@
                 alock.release();
 
-                fireGuestFileOffsetChangedEvent(mEventSource, mSession, this, dataCb.u.seek.uOffActual, 0 /* Processed */);
+                ::FireGuestFileOffsetChangedEvent(mEventSource, mSession, this, dataCb.u.seek.uOffActual, 0 /* Processed */);
             }
             break;
@@ -660,5 +652,5 @@
             Log3ThisFunc(("cbSize=%RU64\n", dataCb.u.SetSize.cbSize));
 
-            fireGuestFileSizeChangedEvent(mEventSource, mSession, this, dataCb.u.SetSize.cbSize);
+            ::FireGuestFileSizeChangedEvent(mEventSource, mSession, this, dataCb.u.SetSize.cbSize);
             rc = VINF_SUCCESS;
             break;
@@ -1067,6 +1059,5 @@
         alock.release(); /* Release lock before firing off event. */
 
-        fireGuestFileStateChangedEvent(mEventSource, mSession,
-                                       this, fileStatus, errorInfo);
+        ::FireGuestFileStateChangedEvent(mEventSource, mSession, this, fileStatus, errorInfo);
     }
 
Index: trunk/src/VBox/Main/src-client/GuestImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/GuestImpl.cpp	(revision 85286)
+++ trunk/src/VBox/Main/src-client/GuestImpl.cpp	(revision 85300)
@@ -960,6 +960,6 @@
     AdditionsRunLevelType_T const enmRunLevel = mData.mAdditionsRunLevel;
     alock.release();
-    fireGuestAdditionsStatusChangedEvent(mEventSource, AdditionsFacilityType_None, AdditionsFacilityStatus_Active,
-                                         enmRunLevel, RTTimeSpecGetMilli(&TimeSpecTS));
+    ::FireGuestAdditionsStatusChangedEvent(mEventSource, AdditionsFacilityType_None, AdditionsFacilityStatus_Active,
+                                           enmRunLevel, RTTimeSpecGetMilli(&TimeSpecTS));
 }
 
@@ -1084,6 +1084,5 @@
     Bstr strDetails; /** @todo Implement state details here. */
 
-    fireGuestUserStateChangedEvent(mEventSource, aUser.raw(), aDomain.raw(),
-                                   (GuestUserState_T)enmState, strDetails.raw());
+    ::FireGuestUserStateChangedEvent(mEventSource, aUser.raw(), aDomain.raw(), (GuestUserState_T)enmState, strDetails.raw());
     LogFlowFuncLeave();
 }
@@ -1143,7 +1142,7 @@
     {
         alock.release();
-        fireGuestAdditionsStatusChangedEvent(mEventSource, (AdditionsFacilityType_T)a_enmFacility,
-                                             (AdditionsFacilityStatus_T)a_enmStatus, enmNewRunLevel,
-                                             RTTimeSpecGetMilli(a_pTimeSpecTS));
+        ::FireGuestAdditionsStatusChangedEvent(mEventSource, (AdditionsFacilityType_T)a_enmFacility,
+                                               (AdditionsFacilityStatus_T)a_enmStatus, enmNewRunLevel,
+                                               RTTimeSpecGetMilli(a_pTimeSpecTS));
     }
 }
@@ -1180,8 +1179,8 @@
         AdditionsRunLevelType_T const enmRunLevel = mData.mAdditionsRunLevel;
         alock.release();
-        fireGuestAdditionsStatusChangedEvent(mEventSource, AdditionsFacilityType_Seamless,
-                                             aCaps & VMMDEV_GUEST_SUPPORTS_SEAMLESS
-                                             ? AdditionsFacilityStatus_Active : AdditionsFacilityStatus_Inactive, enmRunLevel,
-                                             RTTimeSpecGetMilli(&TimeSpecTS));
-    }
-}
+        ::FireGuestAdditionsStatusChangedEvent(mEventSource, AdditionsFacilityType_Seamless,
+                                               aCaps & VMMDEV_GUEST_SUPPORTS_SEAMLESS
+                                               ? AdditionsFacilityStatus_Active : AdditionsFacilityStatus_Inactive,
+                                               enmRunLevel, RTTimeSpecGetMilli(&TimeSpecTS));
+    }
+}
Index: trunk/src/VBox/Main/src-client/GuestProcessImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/GuestProcessImpl.cpp	(revision 85286)
+++ trunk/src/VBox/Main/src-client/GuestProcessImpl.cpp	(revision 85300)
@@ -634,6 +634,5 @@
             alock.release(); /* Release lock before firing off event. */
 
-            fireGuestProcessInputNotifyEvent(mEventSource, mSession, this,
-                                             uPID, 0 /* StdIn */, dataCb.uProcessed, inputStatus);
+            ::FireGuestProcessInputNotifyEvent(mEventSource, mSession, this, uPID, 0 /* StdIn */, dataCb.uProcessed, inputStatus);
         }
     }
@@ -790,6 +789,6 @@
             data.initFrom((BYTE*)dataCb.pvData, dataCb.cbData);
 
-        fireGuestProcessOutputEvent(mEventSource, mSession, this,
-                                    mData.mPID, dataCb.uHandle, dataCb.cbData, ComSafeArrayAsInParam(data));
+        ::FireGuestProcessOutputEvent(mEventSource, mSession, this,
+                                      mData.mPID, dataCb.uHandle, dataCb.cbData, ComSafeArrayAsInParam(data));
     }
 
@@ -971,6 +970,5 @@
         alock.release(); /* Release lock before firing off event. */
 
-        fireGuestProcessStateChangedEvent(mEventSource, mSession, this,
-                                          uPID, procStatus, errorInfo);
+        ::FireGuestProcessStateChangedEvent(mEventSource, mSession, this, uPID, procStatus, errorInfo);
 #if 0
         /*
Index: trunk/src/VBox/Main/src-client/GuestSessionImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/GuestSessionImpl.cpp	(revision 85286)
+++ trunk/src/VBox/Main/src-client/GuestSessionImpl.cpp	(revision 85300)
@@ -1031,5 +1031,5 @@
     alock.release(); /* Release lock before firing off event. */
 
-//    fireGuestDirectoryRegisteredEvent(mEventSource, this /* Session */, pDirConsumed, false /* Process unregistered */);
+//    ::FireGuestDirectoryRegisteredEvent(mEventSource, this /* Session */, pDirConsumed, false /* Process unregistered */);
 
     pDirConsumed.setNull();
@@ -1444,5 +1444,5 @@
     alock.release(); /* Release lock before firing off event. */
 
-    fireGuestFileRegisteredEvent(mEventSource, this, pFileConsumed, false /* Unregistered */);
+    ::FireGuestFileRegisteredEvent(mEventSource, this, pFileConsumed, false /* Unregistered */);
 
     pFileConsumed.setNull();
@@ -1559,5 +1559,5 @@
         alock.release(); /* Release lock before firing off event. */
 
-        fireGuestFileRegisteredEvent(mEventSource, this, pFile, true /* Registered */);
+        ::FireGuestFileRegisteredEvent(mEventSource, this, pFile, true /* Registered */);
     }
     catch (std::bad_alloc &)
@@ -2450,5 +2450,5 @@
     alock.release(); /* Release lock before firing off event. */
 
-    fireGuestProcessRegisteredEvent(mEventSource, this /* Session */, pProc, uPID, false /* Process unregistered */);
+    ::FireGuestProcessRegisteredEvent(mEventSource, this /* Session */, pProc, uPID, false /* Process unregistered */);
 
     pProc.setNull();
@@ -2553,5 +2553,5 @@
         alock.release(); /* Release lock before firing off event. */
 
-        fireGuestProcessRegisteredEvent(mEventSource, this /* Session */, pProcess, 0 /* PID */, true /* Process registered */);
+        ::FireGuestProcessRegisteredEvent(mEventSource, this /* Session */, pProcess, 0 /* PID */, true /* Process registered */);
     }
     catch (std::bad_alloc &)
@@ -2673,6 +2673,5 @@
         AssertRC(rc2);
 
-        fireGuestSessionStateChangedEvent(mEventSource, this,
-                                          mData.mSession.mID, sessionStatus, errorInfo);
+        ::FireGuestSessionStateChangedEvent(mEventSource, this, mData.mSession.mID, sessionStatus, errorInfo);
     }
 
Index: trunk/src/VBox/Main/src-client/KeyboardImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/KeyboardImpl.cpp	(revision 85286)
+++ trunk/src/VBox/Main/src-client/KeyboardImpl.cpp	(revision 85300)
@@ -213,5 +213,5 @@
         keys[i] = aScancodes[i];
 
-    fireGuestKeyboardEvent(mEventSource, ComSafeArrayAsInParam(keys));
+    ::FireGuestKeyboardEvent(mEventSource, ComSafeArrayAsInParam(keys));
 
     if (RT_FAILURE(vrc))
Index: trunk/src/VBox/Main/src-client/MouseImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/MouseImpl.cpp	(revision 85286)
+++ trunk/src/VBox/Main/src-client/MouseImpl.cpp	(revision 85300)
@@ -693,5 +693,5 @@
 
     if (fButtons != 0)
-        fireGuestMouseEvent(mEventSource, mode, x, y, dz, dw, fButtons);
+        ::FireGuestMouseEvent(mEventSource, mode, x, y, dz, dw, fButtons);
     else
     {
@@ -723,6 +723,6 @@
     }
 
-    fireGuestMultiTouchEvent(mEventSource, cContacts, ComSafeArrayAsInParam(xPositions), ComSafeArrayAsInParam(yPositions),
-                             ComSafeArrayAsInParam(contactIds), ComSafeArrayAsInParam(contactFlags), u32ScanTime);
+    ::FireGuestMultiTouchEvent(mEventSource, cContacts, ComSafeArrayAsInParam(xPositions), ComSafeArrayAsInParam(yPositions),
+                               ComSafeArrayAsInParam(contactIds), ComSafeArrayAsInParam(contactFlags), u32ScanTime);
 }
 
Index: trunk/src/VBox/Main/src-client/PCIRawDevImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/PCIRawDevImpl.cpp	(revision 85286)
+++ trunk/src/VBox/Main/src-client/PCIRawDevImpl.cpp	(revision 85300)
@@ -103,5 +103,5 @@
         msg = BstrFmt("runtime error %Rrc", rc);
 
-    fireHostPCIDevicePlugEvent(es, bstrId.raw(), true /* plugged */, RT_SUCCESS_NP(rc) /* success */, pda, msg.raw());
+    ::FireHostPCIDevicePlugEvent(es, bstrId.raw(), true /* plugged */, RT_SUCCESS_NP(rc) /* success */, pda, msg.raw());
 
     return VINF_SUCCESS;
Index: trunk/src/VBox/Main/src-client/VirtualBoxClientImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/VirtualBoxClientImpl.cpp	(revision 85286)
+++ trunk/src/VBox/Main/src-client/VirtualBoxClientImpl.cpp	(revision 85300)
@@ -618,5 +618,5 @@
                         pThis->mData.m_pVirtualBox.setNull();
                     }
-                    fireVBoxSVCAvailabilityChangedEvent(pThis->mData.m_pEventSource, FALSE);
+                    ::FireVBoxSVCAvailabilityChangedEvent(pThis->mData.m_pEventSource, FALSE);
                 }
             }
@@ -642,5 +642,5 @@
                         pThis->mData.m_pToken = pToken;
                     }
-                    fireVBoxSVCAvailabilityChangedEvent(pThis->mData.m_pEventSource, TRUE);
+                    ::FireVBoxSVCAvailabilityChangedEvent(pThis->mData.m_pEventSource, TRUE);
                     cMillies = VBOXCLIENT_DEFAULT_INTERVAL;
                 }