Index: trunk/src/VBox/Frontends/VirtualBox/src/converter/UIConverterBackendGlobal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/converter/UIConverterBackendGlobal.cpp	(revision 85395)
+++ trunk/src/VBox/Frontends/VirtualBox/src/converter/UIConverterBackendGlobal.cpp	(revision 85396)
@@ -1513,12 +1513,13 @@
     switch (enmToolType)
     {
-        case UIToolType_Welcome:           strResult =  "Welcome"; break;
-        case UIToolType_Media:             strResult = "Media"; break;
-        case UIToolType_Network:           strResult = "Network"; break;
-        case UIToolType_Cloud:             strResult = "Cloud"; break;
-        case UIToolType_VMResourceMonitor: strResult = "VM Resource Monitor"; break;
-        case UIToolType_Details:           strResult = "Details"; break;
-        case UIToolType_Snapshots:         strResult = "Snapshots"; break;
-        case UIToolType_Logs:              strResult = "Logs"; break;
+        case UIToolType_Welcome:            strResult =  "Welcome"; break;
+        case UIToolType_Media:              strResult = "Media"; break;
+        case UIToolType_Network:            strResult = "Network"; break;
+        case UIToolType_Cloud:              strResult = "Cloud"; break;
+        case UIToolType_VMResourceMonitor:  strResult = "VM Resource Monitor"; break;
+        case UIToolType_Details:            strResult = "Details"; break;
+        case UIToolType_Snapshots:          strResult = "Snapshots"; break;
+        case UIToolType_Logs:               strResult = "Logs"; break;
+        case UIToolType_PerformanceMonitor: strResult = "Performance Monitor"; break;
         default:
         {
@@ -1544,4 +1545,5 @@
     keys << "Snapshots";             values << UIToolType_Snapshots;
     keys << "Logs";                  values << UIToolType_Logs;
+    keys << "Performance Monitor";   values << UIToolType_PerformanceMonitor;
     /* Invalid type for unknown words: */
     if (!keys.contains(strToolType, Qt::CaseInsensitive))
Index: trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp	(revision 85395)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp	(revision 85396)
@@ -279,4 +279,5 @@
                 case UIToolType_Snapshots:
                 case UIToolType_Logs:
+                case UIToolType_PerformanceMonitor:
                     return true;
                 default:
Index: trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h	(revision 85395)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h	(revision 85396)
@@ -903,4 +903,5 @@
     UIToolType_Snapshots,
     UIToolType_Logs,
+    UIToolType_PerformanceMonitor
 };
 Q_DECLARE_METATYPE(UIToolType);
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPoolManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPoolManager.cpp	(revision 85395)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPoolManager.cpp	(revision 85396)
@@ -1726,4 +1726,36 @@
 };
 
+/** Simple action extension, used as 'Show Performance Monitor' action class. */
+class UIActionToggleSelectorToolsMachineShowPerformanceMonitor : public UIActionToggle
+{
+    Q_OBJECT;
+
+public:
+
+    /** Constructs action passing @a pParent to the base-class. */
+    UIActionToggleSelectorToolsMachineShowPerformanceMonitor(UIActionPool *pParent)
+        : UIActionToggle(pParent)
+    {
+        setProperty("UIToolType", QVariant::fromValue(UIToolType_PerformanceMonitor));
+        /// @todo use icons with check-boxes
+        setIcon(UIIconPool::iconSetFull(":/resources_monitor_32px.png", ":/resources_monitor_16px.png",
+                                        ":/resources_monitor_disabled_32px.png", ":/resources_monitor_disabled_16px.png"));
+    }
+
+protected:
+
+    /** Returns shortcut extra-data ID. */
+    virtual QString shortcutExtraDataID() const /* override */
+    {
+        return QString("ToolsMachinePerformanceMonitor");
+    }
+
+    /** Handles translation event. */
+    virtual void retranslateUi() /* override */
+    {
+        setName(QApplication::translate("UIActionPool", "&PerformanceMonitor"));
+        setStatusTip(QApplication::translate("UIActionPool", "Open the machine performance monitor pane"));
+    }
+};
 
 /** Menu action extension, used as 'Global Tools' menu class. */
@@ -3334,5 +3366,7 @@
     m_pool[UIActionIndexST_M_Group_M_Tools_T_Snapshots] = new UIActionToggleSelectorToolsMachineShowSnapshots(this);
     m_pool[UIActionIndexST_M_Group_M_Tools_T_Logs] = new UIActionToggleSelectorToolsMachineShowLogs(this);
+    m_pool[UIActionIndexST_M_Group_M_Tools_T_PerformanceMonitor] = new UIActionToggleSelectorToolsMachineShowPerformanceMonitor(this);
     m_pool[UIActionIndexST_M_Group_S_Discard] = new UIActionSimpleSelectorCommonPerformDiscard(this);
+    m_pool[UIActionIndexST_M_Group_S_ShowLogDialog] = new UIActionSimpleSelectorCommonShowMachineLogs(this);
     m_pool[UIActionIndexST_M_Group_S_ShowLogDialog] = new UIActionSimpleSelectorCommonShowMachineLogs(this);
     m_pool[UIActionIndexST_M_Group_S_Refresh] = new UIActionSimpleSelectorCommonPerformRefresh(this);
@@ -3445,4 +3479,5 @@
     m_groupPool[UIActionIndexST_M_Group_M_Tools]->addAction(m_pool.value(UIActionIndexST_M_Group_M_Tools_T_Snapshots));
     m_groupPool[UIActionIndexST_M_Group_M_Tools]->addAction(m_pool.value(UIActionIndexST_M_Group_M_Tools_T_Logs));
+    m_groupPool[UIActionIndexST_M_Group_M_Tools]->addAction(m_pool.value(UIActionIndexST_M_Group_M_Tools_T_PerformanceMonitor));
 
     /* 'Machine' action groups: */
@@ -3834,4 +3869,5 @@
     pMenu->addAction(action(UIActionIndexST_M_Group_M_Tools_T_Snapshots));
     pMenu->addAction(action(UIActionIndexST_M_Group_M_Tools_T_Logs));
+    pMenu->addAction(action(UIActionIndexST_M_Group_M_Tools_T_PerformanceMonitor));
 
     /* Mark menu as valid: */
@@ -4165,5 +4201,6 @@
                     << action(UIActionIndexST_M_Group_M_Tools_T_Details)
                     << action(UIActionIndexST_M_Group_M_Tools_T_Snapshots)
-                    << action(UIActionIndexST_M_Group_M_Tools_T_Logs);
+                    << action(UIActionIndexST_M_Group_M_Tools_T_Logs)
+                    << action(UIActionIndexST_M_Group_M_Tools_T_PerformanceMonitor);
             break;
         }
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPoolManager.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPoolManager.h	(revision 85395)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPoolManager.h	(revision 85396)
@@ -83,4 +83,5 @@
     UIActionIndexST_M_Group_M_Tools_T_Snapshots,
     UIActionIndexST_M_Group_M_Tools_T_Logs,
+    UIActionIndexST_M_Group_M_Tools_T_PerformanceMonitor,
     UIActionIndexST_M_Group_S_Discard,
     UIActionIndexST_M_Group_S_ShowLogDialog,
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneMachine.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneMachine.cpp	(revision 85395)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneMachine.cpp	(revision 85396)
@@ -28,4 +28,5 @@
 #include "UIDetails.h"
 #include "UIIconPool.h"
+#include "UIPerformanceMonitor.h"
 #include "UISnapshotPane.h"
 #include "UIToolPaneMachine.h"
@@ -46,4 +47,5 @@
     , m_pPaneSnapshots(0)
     , m_pPaneLogViewer(0)
+    , m_pPanePerformanceMonitor(0)
     , m_fActive(false)
 {
@@ -189,4 +191,22 @@
                 break;
             }
+            case UIToolType_PerformanceMonitor:
+            {
+                m_pPanePerformanceMonitor = new UIPerformanceMonitor(0, m_comMachine);
+                AssertPtrReturnVoid(m_pPanePerformanceMonitor);
+#ifndef VBOX_WS_MAC
+                const int iMargin = qApp->style()->pixelMetric(QStyle::PM_LayoutLeftMargin) / 4;
+                m_pPanePerformanceMonitor->setContentsMargins(iMargin, 0, iMargin, 0);
+#endif
+
+                /* Configure pane: */
+                m_pPanePerformanceMonitor->setProperty("ToolType", QVariant::fromValue(UIToolType_PerformanceMonitor));
+
+                /* Add into layout: */
+                m_pLayout->addWidget(m_pPanePerformanceMonitor);
+                m_pLayout->setCurrentWidget(m_pPanePerformanceMonitor);
+
+                break;
+            }
             default:
                 AssertFailedReturnVoid();
@@ -212,8 +232,9 @@
         switch (enmType)
         {
-            case UIToolType_Error:     m_pPaneError = 0; break;
-            case UIToolType_Details:   m_pPaneDetails = 0; break;
-            case UIToolType_Snapshots: m_pPaneSnapshots = 0; break;
-            case UIToolType_Logs:      m_pPaneLogViewer = 0; break;
+            case UIToolType_Error:                m_pPaneError = 0; break;
+            case UIToolType_Details:              m_pPaneDetails = 0; break;
+            case UIToolType_Snapshots:            m_pPaneSnapshots = 0; break;
+            case UIToolType_Logs:                 m_pPaneLogViewer = 0; break;
+            case UIToolType_PerformanceMonitor:   m_pPanePerformanceMonitor = 0; break;
             default: break;
         }
@@ -274,4 +295,15 @@
         m_pPaneLogViewer->setMachine(m_comMachine);
     }
+    /* Update performance monitor pane is it is open: */
+    if (isToolOpened(UIToolType_PerformanceMonitor))
+    {
+        // AssertPtrReturnVoid(m_pPanePerformanceMonitor);
+        // // CSession comSession = uiCommon().openSession(m_comMachine.GetId(), KLockType_Shared);
+        // // AssertReturnVoid(!comSession.isNull());
+        // // CConsole comConsole = comSession.GetConsole();
+        // AssertReturnVoid(!comConsole.isNull());
+
+        //m_pPaneLogViewer->setMachine(m_comMachine);
+    }
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneMachine.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneMachine.h	(revision 85395)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneMachine.h	(revision 85396)
@@ -39,4 +39,5 @@
 class UIDetails;
 class UIErrorPane;
+class UIPerformanceMonitor;
 class UISnapshotPane;
 class UIVirtualMachineItem;
@@ -125,4 +126,6 @@
     /** Holds the Logviewer pane instance. */
     UIVMLogViewerWidget *m_pPaneLogViewer;
+    /** Holds the Performance Monitor pane instance. */
+    UIPerformanceMonitor *m_pPanePerformanceMonitor;
 
     /** Holds whether this pane is active. */
@@ -136,3 +139,2 @@
 
 #endif /* !FEQT_INCLUDED_SRC_manager_UIToolPaneMachine_h */
-
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp	(revision 85395)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp	(revision 85396)
@@ -492,8 +492,9 @@
     switch (m_pWidget->toolsType())
     {
-        case UIToolType_Media:   sltCloseVirtualMediumManagerWindow(); break;
-        case UIToolType_Network: sltCloseHostNetworkManagerWindow(); break;
-        case UIToolType_Cloud:   sltCloseCloudProfileManagerWindow(); break;
-        case UIToolType_Logs:    sltCloseLogViewerWindow(); break;
+        case UIToolType_Media:              sltCloseVirtualMediumManagerWindow(); break;
+        case UIToolType_Network:            sltCloseHostNetworkManagerWindow(); break;
+        case UIToolType_Cloud:              sltCloseCloudProfileManagerWindow(); break;
+        case UIToolType_Logs:               sltCloseLogViewerWindow(); break;
+        case UIToolType_PerformanceMonitor: sltClosePerformanceMonitorWindow(); break;
         default: break;
     }
@@ -1786,4 +1787,12 @@
         }
     }
+}
+
+void UIVirtualBoxManager::sltOpenPerformanceMonitorWindow()
+{
+}
+
+void UIVirtualBoxManager::sltClosePerformanceMonitorWindow()
+{
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.h	(revision 85395)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.h	(revision 85396)
@@ -285,4 +285,10 @@
         /** Handles call to close machine Log Viewer window. */
         void sltCloseLogViewerWindow();
+
+        /** Handles call to open machine Performance Monitor window. */
+        void sltOpenPerformanceMonitorWindow();
+
+        /** Handles call to close machine Performance Monitor window. */
+        void sltClosePerformanceMonitorWindow();
 
         /** Handles call to refresh machine. */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp	(revision 85395)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp	(revision 85396)
@@ -828,4 +828,8 @@
                     break;
                 }
+                case UIToolType_PerformanceMonitor:
+                {
+                    break;
+                }
                 case UIToolType_Error:
                 {
@@ -935,11 +939,15 @@
     const bool fCurrentItemIsOk = pItem && pItem->accessible();
 
-    /* Update machine tools restrictions: */
+    /* Update machine 1tools restrictions: */
     QList<UIToolType> retrictedTypes;
     if (pItem && pItem->itemType() != UIVirtualMachineItemType_Local)
     {
-        retrictedTypes << UIToolType_Snapshots << UIToolType_Logs;
+        retrictedTypes << UIToolType_Snapshots << UIToolType_Logs << UIToolType_PerformanceMonitor;
         if (retrictedTypes.contains(m_pPaneTools->toolsType()))
             m_pPaneTools->setToolsType(UIToolType_Details);
+    }
+    if (pItem && !pItem->isItemRunning())
+    {
+        retrictedTypes << UIToolType_PerformanceMonitor;
     }
     m_pPaneTools->setRestrictedToolTypes(retrictedTypes);
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsModel.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsModel.cpp	(revision 85395)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsModel.cpp	(revision 85396)
@@ -440,12 +440,13 @@
         switch (pItem->itemType())
         {
-            case UIToolType_Welcome:            pItem->reconfigure(tr("Welcome")); break;
-            case UIToolType_Media:              pItem->reconfigure(tr("Media")); break;
-            case UIToolType_Network:            pItem->reconfigure(tr("Network")); break;
-            case UIToolType_Cloud:              pItem->reconfigure(tr("Cloud")); break;
-            case UIToolType_VMResourceMonitor:  pItem->reconfigure(tr("Resources")); break;
-            case UIToolType_Details:            pItem->reconfigure(tr("Details")); break;
-            case UIToolType_Snapshots:          pItem->reconfigure(tr("Snapshots")); break;
-            case UIToolType_Logs:               pItem->reconfigure(tr("Logs")); break;
+            case UIToolType_Welcome:             pItem->reconfigure(tr("Welcome")); break;
+            case UIToolType_Media:               pItem->reconfigure(tr("Media")); break;
+            case UIToolType_Network:             pItem->reconfigure(tr("Network")); break;
+            case UIToolType_Cloud:               pItem->reconfigure(tr("Cloud")); break;
+            case UIToolType_VMResourceMonitor:   pItem->reconfigure(tr("Resources")); break;
+            case UIToolType_Details:             pItem->reconfigure(tr("Details")); break;
+            case UIToolType_Snapshots:           pItem->reconfigure(tr("Snapshots")); break;
+            case UIToolType_Logs:                pItem->reconfigure(tr("Logs")); break;
+            case UIToolType_PerformanceMonitor:  pItem->reconfigure(tr("Performance Monitor")); break;
             default: break;
         }
@@ -521,4 +522,7 @@
     m_items << new UIToolsItem(scene(), UIToolClass_Machine, UIToolType_Logs, QString(),
                                UIIconPool::iconSet(":/vm_show_logs_24px.png", ":/vm_show_logs_disabled_24px.png"));
+    /* Performance Monitor: */
+    m_items << new UIToolsItem(scene(), UIToolClass_Machine, UIToolType_PerformanceMonitor, QString(),
+                               UIIconPool::iconSet(":/resource_monitor_24px.png", ":/vm_resource_monitor_24px.png"));
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/monitor/performance/UIPerformanceMonitor.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/monitor/performance/UIPerformanceMonitor.cpp	(revision 85395)
+++ trunk/src/VBox/Frontends/VirtualBox/src/monitor/performance/UIPerformanceMonitor.cpp	(revision 85396)
@@ -32,4 +32,5 @@
 
 /* COM includes: */
+#include "CConsole.h"
 #include "CGuest.h"
 #include "CPerformanceCollector.h"
@@ -698,9 +699,7 @@
 *********************************************************************************************************************************/
 
-UIPerformanceMonitor::UIPerformanceMonitor(QWidget *pParent, const CMachine &machine, const CConsole &console)
+UIPerformanceMonitor::UIPerformanceMonitor(QWidget *pParent, const CMachine &machine)
     : QIWithRetranslateUI<QWidget>(pParent)
     , m_fGuestAdditionsAvailable(false)
-    , m_machine(machine)
-    , m_console(console)
     , m_pMainLayout(0)
     , m_pTimer(0)
@@ -713,6 +712,5 @@
     , m_iTimeStep(0)
 {
-    if (!m_console.isNull())
-        m_comGuest = m_console.GetGuest();
+    setMachine(machine);
     m_fGuestAdditionsAvailable = guestAdditionsAvailable(6 /* minimum major version */);
 
@@ -725,4 +723,23 @@
 UIPerformanceMonitor::~UIPerformanceMonitor()
 {
+}
+
+void UIPerformanceMonitor::setMachine(const CMachine &comMachine)
+{
+    if (comMachine.isNull())
+        return;
+
+    if (!m_comSession.isNull() && m_comSession.GetState() == KSessionState_Locked)
+        m_comSession.UnlockMachine();
+
+    m_comMachine = comMachine;
+    m_comSession = uiCommon().openSession(m_comMachine.GetId(), KLockType_Shared);
+    AssertReturnVoid(!m_comSession.isNull());
+
+    CConsole comConsole = m_comSession.GetConsole();
+    AssertReturnVoid(!comConsole.isNull());
+    m_comGuest = comConsole.GetGuest();
+
+    m_comMachineDebugger = comConsole.GetDebugger();
 }
 
@@ -878,5 +895,5 @@
         ULONG aPctHalted;
         ULONG aPctOther;
-        m_machineDebugger.GetCPULoad(0x7fffffff, aPctExecuting, aPctHalted, aPctOther);
+        m_comMachineDebugger.GetCPULoad(0x7fffffff, aPctExecuting, aPctHalted, aPctOther);
         updateCPUGraphsAndMetric(aPctExecuting, aPctOther);
     }
@@ -886,5 +903,5 @@
         quint64 cbNetworkTotalReceived = 0;
         quint64 cbNetworkTotalTransmitted = 0;
-        UIMonitorCommon::getNetworkLoad(m_machineDebugger, cbNetworkTotalReceived, cbNetworkTotalTransmitted);
+        UIMonitorCommon::getNetworkLoad(m_comMachineDebugger, cbNetworkTotalReceived, cbNetworkTotalTransmitted);
         updateNetworkGraphsAndMetric(cbNetworkTotalReceived, cbNetworkTotalTransmitted);
     }
@@ -894,5 +911,5 @@
         quint64 cbDiskIOTotalWritten = 0;
         quint64 cbDiskIOTotalRead = 0;
-        UIMonitorCommon::getDiskLoad(m_machineDebugger, cbDiskIOTotalWritten, cbDiskIOTotalRead);
+        UIMonitorCommon::getDiskLoad(m_comMachineDebugger, cbDiskIOTotalWritten, cbDiskIOTotalRead);
         updateDiskIOGraphsAndMetric(cbDiskIOTotalWritten, cbDiskIOTotalRead);
     }
@@ -901,5 +918,5 @@
     {
         quint64 cTotalVMExits = 0;
-        UIMonitorCommon::getVMMExitCount(m_machineDebugger, cTotalVMExits);
+        UIMonitorCommon::getVMMExitCount(m_comMachineDebugger, cTotalVMExits);
         updateVMExitMetric(cTotalVMExits);
     }
@@ -918,5 +935,4 @@
 {
     m_performanceMonitor = uiCommon().virtualBox().GetPerformanceCollector();
-    m_machineDebugger = m_console.GetDebugger();
     if (m_performanceMonitor.isNull())
         return;
Index: trunk/src/VBox/Frontends/VirtualBox/src/monitor/performance/UIPerformanceMonitor.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/monitor/performance/UIPerformanceMonitor.h	(revision 85395)
+++ trunk/src/VBox/Frontends/VirtualBox/src/monitor/performance/UIPerformanceMonitor.h	(revision 85396)
@@ -29,9 +29,9 @@
 /* COM includes: */
 #include "COMEnums.h"
-#include "CConsole.h"
 #include "CGuest.h"
 #include "CMachine.h"
 #include "CMachineDebugger.h"
 #include "CPerformanceCollector.h"
+#include "CSession.h"
 
 /* GUI includes: */
@@ -109,8 +109,8 @@
 
     /** Constructs information-tab passing @a pParent to the QWidget base-class constructor.
-      * @param machine is machine reference.
-      * @param console is machine console reference. */
-    UIPerformanceMonitor(QWidget *pParent, const CMachine &machine, const CConsole &console);
+      * @param machine is machine reference. */
+    UIPerformanceMonitor(QWidget *pParent, const CMachine &machine);
     ~UIPerformanceMonitor();
+    void setMachine(const CMachine &machine);
 
  public slots:
@@ -150,10 +150,10 @@
 
     bool m_fGuestAdditionsAvailable;
-    CMachine m_machine;
-    CConsole m_console;
+    CMachine m_comMachine;
+    CSession m_comSession;
     CGuest m_comGuest;
 
     CPerformanceCollector m_performanceMonitor;
-    CMachineDebugger      m_machineDebugger;
+    CMachineDebugger      m_comMachineDebugger;
     /** Holds the instance of layout we create. */
     QVBoxLayout *m_pMainLayout;
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIVMInformationDialog.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIVMInformationDialog.cpp	(revision 85395)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIVMInformationDialog.cpp	(revision 85396)
@@ -200,5 +200,5 @@
         /* Create Performance Monitor tab: */
         UIPerformanceMonitor *pPerformanceMonitorWidget =
-            new UIPerformanceMonitor(this, m_pMachineWindow->machine(), m_pMachineWindow->console());
+            new UIPerformanceMonitor(this, m_pMachineWindow->machine());
         if (pPerformanceMonitorWidget)
         {