Index: trunk/src/VBox/ValidationKit/tests/api/tdMoveVm1.py
===================================================================
--- trunk/src/VBox/ValidationKit/tests/api/tdMoveVm1.py	(revision 85463)
+++ trunk/src/VBox/ValidationKit/tests/api/tdMoveVm1.py	(revision 85464)
@@ -51,4 +51,7 @@
 
 
+# @todo r=aeichner: The whole path handling/checking needs fixing to also work on Windows
+#                   The current quick workaround is to spill os.path.normcase() all over the place when
+#                   constructing paths. I'll leave the real fix to the original author...
 class SubTstDrvMoveVm1(base.SubTestDriverBase):
     """
@@ -198,5 +201,5 @@
                     aoMediumAttachments = oMachine.getMediumAttachmentsOfController(sValue) ##@todo r=bird: API call, try-except!
                     for oAttachment in aoMediumAttachments:
-                        aActuals.add(oAttachment.medium.location)
+                        aActuals.add(os.path.normcase(oAttachment.medium.location))
 
             elif sKey == 'SnapshotFile':
@@ -209,5 +212,5 @@
                 aReferences = dsReferenceFiles[sKey]
                 if aReferences:
-                    aActuals.add(oMachine.settingsFilePath)
+                    aActuals.add(os.path.normcase(oMachine.settingsFilePath))
 
             # Check saved state files location
@@ -234,5 +237,5 @@
 
                 reporter.log('####### Reference locations: #######')
-                for eachItem in aReferences:
+                for eachItem in aActuals:
                     reporter.log(' "%s"' % (eachItem))
 
@@ -256,8 +259,8 @@
     def __getStatesFiles(self, oMachine, fPrint = False):
         asStateFilesList = set()
-        sFolder = oMachine.snapshotFolder
+        sFolder = oMachine.snapshotFolder;
         for sFile in self.__safeListDir(sFolder):
             if sFile.endswith(".sav"):
-                sFullPath = os.path.join(sFolder, sFile)
+                sFullPath = os.path.normcase(os.path.join(sFolder, sFile));
                 asStateFilesList.add(sFullPath)
                 if fPrint is True:
@@ -270,5 +273,5 @@
         for sFile in self.__safeListDir(sFolder):
             if sFile.endswith(".sav") is False:
-                sFullPath = os.path.join(sFolder, sFile)
+                sFullPath = os.path.normcase(os.path.join(sFolder, sFile));
                 asSnapshotsFilesList.add(sFullPath)
                 if fPrint is True:
@@ -281,5 +284,5 @@
         for sFile in self.__safeListDir(sFolder):
             if sFile.endswith(".log"):
-                sFullPath = os.path.join(sFolder, sFile)
+                sFullPath = os.path.normcase(os.path.join(sFolder, sFile));
                 asLogFilesList.add(sFullPath)
                 if fPrint is True:
@@ -305,8 +308,8 @@
         for s in self.asImagesNames:
             reporter.log('"%s"' % (s,))
-            dsReferenceFiles['StandardImage'].add(sNewLoc + os.sep + oMachine.name + os.sep + s)
+            dsReferenceFiles['StandardImage'].add(os.path.normcase(sNewLoc + os.sep + oMachine.name + os.sep + s))
 
         sSettingFile = os.path.join(sNewLoc, os.path.join(oMachine.name, oMachine.name + '.vbox'))
-        dsReferenceFiles['SettingsFile'].add(sSettingFile)
+        dsReferenceFiles['SettingsFile'].add(os.path.normcase(sSettingFile))
 
         fRc = self.moveVMToLocation(sNewLoc, oSession.o.machine)
@@ -347,9 +350,9 @@
             for oAttachment in aoMediumAttachments:
                 sRes = oAttachment.medium.location.rpartition(os.sep)
-                dsReferenceFiles['SnapshotFile'].add(sNewLoc + os.sep + oMachine.name + os.sep +
-                                                     'Snapshots' + os.sep + sRes[2])
+                dsReferenceFiles['SnapshotFile'].add(os.path.normcase(sNewLoc + os.sep + oMachine.name + os.sep +
+                                                     'Snapshots' + os.sep + sRes[2]))
 
             sSettingFile = os.path.join(sNewLoc, os.path.join(oMachine.name, oMachine.name + '.vbox'))
-            dsReferenceFiles['SettingsFile'].add(sSettingFile)
+            dsReferenceFiles['SettingsFile'].add(os.path.normcase(sSettingFile))
 
             fRc = self.moveVMToLocation(sNewLoc, oSession.o.machine)
@@ -403,10 +406,12 @@
             for sFile in asLogs:
                 sRes = sFile.rpartition(os.sep)
-                dsReferenceFiles['LogFile'].add(sNewLoc + os.sep + oMachine.name + os.sep + 'Logs' + os.sep + sRes[2])
+                dsReferenceFiles['LogFile'].add(os.path.normcase(sNewLoc + os.sep + oMachine.name + os.sep +
+                                                'Logs' + os.sep + sRes[2]))
 
             asStates = self.__getStatesFiles(oMachine)
             for sFile in asStates:
                 sRes = sFile.rpartition(os.sep)
-                dsReferenceFiles['SavedStateFile'].add(sNewLoc + os.sep + oMachine.name + os.sep + 'Snapshots' + os.sep + sRes[2])
+                dsReferenceFiles['SavedStateFile'].add(os.path.normcase(sNewLoc + os.sep + oMachine.name + os.sep +
+                                                       'Snapshots' + os.sep + sRes[2]))
 
             fRc = self.moveVMToLocation(sNewLoc, oSession.o.machine)
@@ -472,5 +477,5 @@
             iPort = len(aoMediumAttachments)
             fRc = oSession.attachDvd(sISOLoc, sController, iPort, iDevice = 0)
-            dsReferenceFiles['ISOImage'].add(os.path.join(os.path.join(sNewLoc, oMachine.name), sISOImageName))
+            dsReferenceFiles['ISOImage'].add(os.path.normcase(os.path.join(os.path.join(sNewLoc, oMachine.name), sISOImageName)))
 
         if fRc is True:
@@ -532,5 +537,5 @@
             sController=self.dsKeys['FloppyImage']
             fRc = fRc and oSession.attachFloppy(sFloppyLoc, sController, 0, 0)
-            dsReferenceFiles['FloppyImage'].add(os.path.join(os.path.join(sNewLoc, oMachine.name), sFloppyImageName))
+            dsReferenceFiles['FloppyImage'].add(os.path.normcase(os.path.join(os.path.join(sNewLoc, oMachine.name), sFloppyImageName)))
 
         if fRc is True:
@@ -626,7 +631,7 @@
             for s in self.asImagesNames:
                 reporter.log('"%s"' % (s,))
-                dsReferenceFiles['StandardImage'].add(os.path.join(sOrigLoc, s))
-
-            sSettingFile = os.path.join(sNewLoc, os.path.join(oMachine.name, oMachine.name + '.vbox'))
+                dsReferenceFiles['StandardImage'].add(os.path.normcase(os.path.join(sOrigLoc, s)))
+
+            sSettingFile = os.path.normcase(os.path.join(sNewLoc, os.path.join(oMachine.name, oMachine.name + '.vbox')))
             dsReferenceFiles['SettingsFile'].add(sSettingFile)
 