Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.cpp	(revision 85493)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.cpp	(revision 85508)
@@ -195,10 +195,10 @@
                     /* Configure pane: */
                     m_pPaneResourceMonitor->setProperty("ToolType", QVariant::fromValue(UIToolType_Resources));
+                    connect(m_pPaneResourceMonitor, &UIResourceMonitorWidget::sigSwitchToMachinePerformancePane,
+                            this, &UIToolPaneGlobal::sigSwitchToMachinePerformancePane);
 
                     /* Add into layout: */
                     m_pLayout->addWidget(m_pPaneResourceMonitor);
                     m_pLayout->setCurrentWidget(m_pPaneResourceMonitor);
-                    connect(m_pPaneResourceMonitor, &UIResourceMonitorWidget::sigSwitchMachinePerformancePane,
-                            this, &UIToolPaneGlobal::sigSwitchMachinePerformancePane);
                 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.h	(revision 85493)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.h	(revision 85508)
@@ -51,5 +51,7 @@
     /** Notifies listeners about Cloud Profile Manager change. */
     void sigCloudProfileManagerChange();
-    void sigSwitchMachinePerformancePane(const QUuid &machineUid);
+
+    /** Notifies listeners about request to switch to Performance pane of machine with @a uMachineId. */
+    void sigSwitchToMachinePerformancePane(const QUuid &uMachineId);
 
 public:
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp	(revision 85493)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp	(revision 85508)
@@ -28,5 +28,4 @@
 #include "UIExtraDataManager.h"
 #include "UIChooser.h"
-#include "UICommon.h"
 #include "UIVirtualBoxManager.h"
 #include "UIVirtualBoxManagerWidget.h"
@@ -460,17 +459,10 @@
 }
 
-void UIVirtualBoxManagerWidget::sltSwitchMachinePerformancePane(const QUuid &machineUid)
-{
-    if (!m_pPaneToolsMachine)
-        return;
-    CVirtualBox comVBox = uiCommon().virtualBox();
-
-    CMachine comMachine = comVBox.FindMachine(machineUid.toString());
-    if (comMachine.isNull())
-        return;
-    m_pPaneToolsMachine->setActive(true);
-    m_pPaneToolsGlobal->setActive(false);
-    m_pPaneToolsMachine->setMachine(comMachine);
-    switchToMachineTool(UIToolType_Performance);
+void UIVirtualBoxManagerWidget::sltSwitchToMachinePerformancePane(const QUuid &uMachineId)
+{
+    AssertPtrReturnVoid(m_pPaneChooser);
+    AssertPtrReturnVoid(m_pPaneTools);
+    m_pPaneChooser->setCurrentMachine(uMachineId);
+    m_pPaneTools->setToolsType(UIToolType_Performance);
 }
 
@@ -572,6 +564,6 @@
                             connect(m_pPaneToolsGlobal, &UIToolPaneGlobal::sigCloudProfileManagerChange,
                                     this, &UIVirtualBoxManagerWidget::sigCloudProfileManagerChange);
-                            connect(m_pPaneToolsGlobal, &UIToolPaneGlobal::sigSwitchMachinePerformancePane,
-                                    this, &UIVirtualBoxManagerWidget::sltSwitchMachinePerformancePane);
+                            connect(m_pPaneToolsGlobal, &UIToolPaneGlobal::sigSwitchToMachinePerformancePane,
+                                    this, &UIVirtualBoxManagerWidget::sltSwitchToMachinePerformancePane);
 
                             /* Add into stack: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.h	(revision 85493)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.h	(revision 85508)
@@ -251,6 +251,6 @@
         void sltHandleToolsPaneIndexChange();
 
-        /** Handles signal requesting performance pane switch. */
-        void sltSwitchMachinePerformancePane(const QUuid &machineUid);
+        /** Handles signal requesting switch to Performance pane of machine with @a uMachineId. */
+        void sltSwitchToMachinePerformancePane(const QUuid &uMachineId);
     /** @} */
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooser.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooser.cpp	(revision 85493)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooser.cpp	(revision 85508)
@@ -158,4 +158,10 @@
     AssertPtrReturnVoid(view());
     view()->setSearchWidgetVisible(fVisible);
+}
+
+void UIChooser::setCurrentMachine(const QUuid &uId)
+{
+    AssertPtrReturnVoid(model());
+    model()->setCurrentMachineItem(uId);
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooser.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooser.h	(revision 85493)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooser.h	(revision 85508)
@@ -152,4 +152,6 @@
         /** Toggle machine search widget to be @a fVisible. */
         void setMachineSearchWidgetVisibility(bool fVisible);
+        /** Changes current machine to the one with certain @a uId. */
+        void setCurrentMachine(const QUuid &uId);
     /** @} */
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp	(revision 85493)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp	(revision 85508)
@@ -959,4 +959,16 @@
     /* Rebuild tree for main root: */
     buildTreeForMainRoot(true /* preserve selection */);
+}
+
+void UIChooserModel::setCurrentMachineItem(const QUuid &uId)
+{
+    /* Look whether we have such item at all: */
+    UIChooserItem *pItem = root()->searchForItem(uId.toString(),
+                                                 UIChooserItemSearchFlag_Machine |
+                                                 UIChooserItemSearchFlag_ExactId);
+
+    /* Select item if exists: */
+    if (pItem)
+        setSelectedItem(pItem);
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.h	(revision 85493)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.h	(revision 85508)
@@ -222,4 +222,6 @@
         /** Sorts selected [parent] group item. */
         void sortSelectedGroupItem();
+        /** Changes current machine item to the one with certain @a uId. */
+        void setCurrentMachineItem(const QUuid &uId);
 
         /** Defines current @a pDragObject. */
Index: trunk/src/VBox/Frontends/VirtualBox/src/monitor/resource/UIResourceMonitor.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/monitor/resource/UIResourceMonitor.cpp	(revision 85493)
+++ trunk/src/VBox/Frontends/VirtualBox/src/monitor/resource/UIResourceMonitor.cpp	(revision 85508)
@@ -1478,8 +1478,8 @@
     if (!m_pTableView || !m_pModel)
         return;
-    QUuid machineId = m_pModel->itemUid(m_pTableView->selectedItemIndex());
-    if (machineId.isNull())
+    const QUuid uMachineId = m_pModel->itemUid(m_pTableView->selectedItemIndex());
+    if (uMachineId.isNull())
         return;
-    emit sigSwitchMachinePerformancePane(machineId);
+    emit sigSwitchToMachinePerformancePane(uMachineId);
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/monitor/resource/UIResourceMonitor.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/monitor/resource/UIResourceMonitor.h	(revision 85493)
+++ trunk/src/VBox/Frontends/VirtualBox/src/monitor/resource/UIResourceMonitor.h	(revision 85508)
@@ -51,5 +51,5 @@
 signals:
 
-    void sigSwitchMachinePerformancePane(const QUuid &machineId);
+    void sigSwitchToMachinePerformancePane(const QUuid &uMachineId);
 
 public: